% In this step, the objective was removed and a flat mirror was place at
% the back focal plane
% This code shows the control of deformable mirror(DM) and shack-hartmann
% wavefront sensor(SHWS) for calibration zernike modes as the basis for
% wavefront reconstruction, wavefront(wf) spots images were acquired from
% SHWS corresponding to zernike modes z1 to z60 applied onto DM
% ScanImage, DM and SHWS required

%load Z2C matrix
load('Z2C.mat');
%set zero phase
Czero=zeros(1,97);
%set command zernike mode, z1 to z60 with 1um peak to valley amplitude
DM_calibration_factor=ones(1,60);
Vmatrix=diag(DM_calibration_factor);

% start calibrating
h = waitbar(0,'Calibrating...');
imgsum = int16(zeros(1024,1024));
%send Z1 to Z60 zernike pattern in sequence and take SHWS image when each
%zernike mode was applied onto DM
for i=1:60
    DMcommand(i,:) = (Vmatrix(i,:)*Z2C);
    % Send command to DM
    hAOROIctrl.hDMctrl.senddata(DMcommand(i,:));
    pause(0.5);
    
    % acquire wf spots images from SHWS, average 4 times
    for k = 1:4
        imgdata = hAOROIctrl.hSHctrl.takeSHdata;
        imgsum = imgsum + imgdata;
    end
    DM_calibration_shdata(:,:,i)=imgsum/4;
    imgsum = int16(zeros(1024,1024));
    
    waitbar(i/60);
end
close(h);
% calibration is done, send zero pattern to DM
hAOROIctrl.hDMctrl.senddata(Czero); 


